#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cstdio>

#define stackInit if (!stack.size()) { stack.push_back(0); stackTop = stack.rbegin(); }
#define stackPop(x) stack.pop_back(); if (stack.size()) { stackTop = stack.rbegin(); } if(x) { stackInit; }
#define stackPush(x) stack.push_back(x); if (stack.size()) { stackTop = stack.rbegin(); } stackInit;

#define getc() fs.get()
typedef unsigned int uint;
using namespace std;

uint lines;
string err;
char firstC = 0;
bool repeated;
vector<uint> stack;
vector<uint>::reverse_iterator stackTop;
vector<pair<uint, uint> > toDoStack; //From - to

void printAllToDo() {
    for (vector<pair<uint, uint> >::reverse_iterator it = toDoStack.rbegin(); it != toDoStack.rend(); it ++) {
        for (uint j = it->first; j < it->second; j ++) {
            printf("%c", err[j]);
        }
    }
    toDoStack.clear();
}

void printAll() {
    for (vector<uint>::iterator it = stack.begin(); it != stack.end(); it ++) {
        for (uint j = 0; j < *it; j ++) {
            printf("%c", err[j]);
        }
    }
    stack.clear();
    stackInit;
}

bool apply(char c, bool dontFork) {
    if (*stackTop > 0) {
        if (c == firstC && !dontFork) {
            stackPush(1);
            return true;
        }
        else if (c == err[*stackTop]) {
            *stackTop ++;
            if (*stackTop == err.size()) { //Found BUG
                stackPop(true);
            }
            return true;
        }
    }
    else if (c == firstC) { //Start new one
        *stackTop ++;
        return true;
    }
    return false;
}


int main()
{
    FILE* in = fopen("bugs.in", "r");
    while(true) {
        if (fscanf(in, "%d", &lines) == EOF) return 0;
        getc(); //space
        firstC = 0;
        repeated = false;
        for (char c = getc(); c != '\n'; c = getc()) {
            err.push_back(c);
            if (!firstC) firstC = c;
            else if (firstC == c) repeated = true;
        }
        printf("%s\n", err.c_str());
        stackInit;
        pair<uint, uint> tmpPair = make_pair(0, 0);
        for (uint i = 0; i < lines; i ++) {
            char c = getc();
            do {
                bool fromStack = toDoStack.size();
                const pair<uint, uint> &back = (fromStack ? toDoStack.back() : tmpPair );
                char d = (fromStack ? err[back.first] : c);
                if (apply(d, fromStack && back.first == 0)) { //Applied - good
                    if (fromStack) {
                        if ((back.first + 1) == back.second) { //Finished whole word
                            toDoStack.pop_back();
                        }
                        else {
                            toDoStack.rbegin()->second ++; //Increment if you did not
                        }
                    }
                    continue;
                }
                if (stack.size()) { //Did not applied
                    if (repeated) { //Need toDoStack
                        toDoStack.push_back(make_pair(0, *stackTop));
                        stackPop(false);
                        if (!stack.size()) {
                            printAllToDo();
                            stackInit;
                        }
                    }
                    else { //Do not need toDo stack
                        printAll();
                    }
                    printf("%c", c);
                }
            } while (toDoStack.size());
        }
    }

    return 0;
}
